/* File: CClassApp.c
// A  C program that creates "instances" of "classes" and invokes "methods"
//
*/
#include <avr/io.h>
#include <avr/interrupt.h>

//#include "point.h"
#include "rectangle.h" // typedefs and prototypes
#include "circle.h"

// TODO: No code modifications need to be made here; just make it build and run

int main()			/* every C program needs a "main" */
{
    Point p1, p2;       // unitialized Points
    _Point(&p1, 0, 0);  // constructor for p1; pass in "this" pointer and x,y coordinates
    _Point(&p2, 5, 5);  // constructor for p2

    Rectangle r1;       // uninitialized Rectangle

    _Rectangle(&r1, p1, p2); // "constructor"; pass in "this" pointer and p1, p2 coordinate pairs

    int rArea = r1.getArea(&r1);  // "methods" of the "class" are really function pointers
    int rPerim = r1.getPerimeter(&r1);

    Circle c; // uninitialized Circle

    _Circle(&c, p1, 5.0); // call the "constructor"; pass in a pointer to be used as "this"

    float cArea = c.getArea(&c);  // call methods of the "class" via function pointers; pass in a "this" pointer
    float cPerim = c.getCircumference(&c); // Note: we have to keep passing in a "this" pointer

    int total = cArea + rArea; // just needed for debugging
}
